<?php
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );
// including a Adapter LIB
$adapterLibFile = JPATH_ADMINISTRATOR.DS."components".DS."com_noixacl".DS."libraries".DS."adapter.php";
if( file_exists($adapterLibFile) ){
	include $adapterLibFile;
}
/**
 * Example system plugin
 */
class plgSystemNoixACL extends JPlugin
{
	/**
	 * Constructor
	 */
	public function plgSystemNoixACL( &$subject, $config )
	{
		parent::__construct( $subject, $config );
	}
	
	/**
	 * Do load rulles and start checking function
	 */
	public function onAfterRoute()
	{
		$adapterLibFile = JPATH_ADMINISTRATOR.DS."components".DS."com_noixacl".DS."libraries".DS."adapter.php";
		
		//return false if not exists file
		if( !file_exists($adapterLibFile) ){
			return false;
		}
		
		$db = JFactory::getDBO();
		$app =& JFactory::getApplication();
		$user = Jfactory::getUSER();
		$acl =& JFactory::getACL();

		//if user not logged return false;
		if( $user->id == 0 ){
			return false;
		}

		//geting usertype from user
		$arrMultiGroups[] = $user->usertype;

		//get multigrop names if user have it
		$sqlGetMultigroups = "SELECT grp.name FROM #__core_acl_aro_groups as grp, #__noixacl_multigroups multigrp WHERE grp.id = multigrp.id_group AND multigrp.id_user = {$user->id}";
		$db->setQuery( $sqlGetMultigroups );
		$multiGroups = $db->loadObjectList();

		if( !empty($multiGroups) ){
			foreach($multiGroups as $mgrp){
				$arrMultiGroups[] = $mgrp->name;
			}
		}

        //geting rules from multigroups
		$acl_sql = "SELECT aco_section,aco_value,aro_section,aro_value,axo_section,axo_value FROM #__noixacl_rules WHERE aro_section = 'users' AND aro_value IN ('". implode("','",$arrMultiGroups) ."')";
		$db->setQuery( $acl_sql );
		$rulles = $db->loadObjectList();

		if( count($rulles) > 0 ){
			/**
			 * Adding a rule to joomlaACL
			 */
			foreach($rulles as $r){
				$acl->addACL( $r->aco_section, $r->aco_value, $r->aro_section, $user->usertype, $r->axo_section, $r->axo_value );
			}
		}
		
        $this->controlAdapterAccess();
	}

	public function controlAdapterAccess()
	{
		//instance application
		$app =& JFactory::getApplication();
		//get component
		$option = JRequest::getCMD('option');
		//instance adapters lib
		$adapterControl = new Adapters();
		//get name of application
		$applicationName = $app->getName();
		
		$this->redirectAdminComUsers();
		
		//verify if access a component
		if( !empty($option) ){
			
			//geting a Adapter
			$myAdapter = $adapterControl->getAdapter($option);
			$this->executeAdapterPlugin($option);
			
			if( $applicationName == 'site' ){
				//get Itemid
				$Itemid = JRequest::getInt('Itemid');
				
				if( $Itemid > 0 ){
					$myAdapter = $adapterControl->getAdapter('com_menus');
					$this->executeAdapterPlugin($myAdapter);
				}
			}
		}
		
		//get all adapters
		$listAdapters = $adapterControl->listAdapters();
		if( !empty( $listAdapters ) ){
			foreach($listAdapters as $adapterObject){
				if( $adapterObject->xmlData["pluginExecution"] == 'independent'){
					$this->executeAdapterPlugin($adapterObject,false);
				}
			}
		}
	}
	
	public function redirectAdminComUsers()
	{
		//instance application
		$app =& JFactory::getApplication();
		//get component
		$option = JRequest::getCMD('option');
		//get name of application
		$applicationName = $app->getName();
		
		//verify if access a component
		if( !empty($option) ){
			//if try access com_users you go redirect to noixACL users
			if($option == 'com_users' && $applicationName == 'administrator'){
				//get task execution
				$task = JRequest::getCMD('task');
				//url to recdirect
				$urlUsers = 'index.php?option=com_noixacl&controller=aclusers';

				if( $task == 'edit' ){
					$cid = JRequest::getVar('cid');
					$urlUsers .= '&task=edit&cid[]='.intval($cid[0]);
				}
				
				$app->redirect($urlUsers,"");
				return false;
			}
		}
	}
	
	public function executeAdapterPlugin($myAdapter,$checkRule = true)
	{
		//instance application
		$app =& JFactory::getApplication();
		//get component
		$option = JRequest::getCMD('option');
		//instance adapters lib
		$adapterControl = new Adapters();
		//get name of application
		$applicationName = $app->getName();
		
		if( is_object($myAdapter) ){
			//include file
			if( !file_exists($myAdapter->xmlData['pathPlugin']) ){
				JError::raiseError('noixACL',JText::_('Plugin adapter file not exists'));
				return false;
			}
			
			//include adapter plugin file
			include $myAdapter->xmlData['pathPlugin'];
			//instance a plugin
			$instancePlugin = new $myAdapter->xmlData['plugin'];
			//call method same name of application in plugin of adapter
			if( method_exists($instancePlugin,$applicationName) ){
				//get params from
				$pluginParams = $instancePlugin->$applicationName();
				if( $checkRule ){
					//checking rulle access
					$canAccess = $adapterControl->checkRule($applicationName,$myAdapter,$pluginParams);
					/**
					 * block access
					 */
					
					if( !$canAccess ){
						JError::raiseError('noixACL',JText::_('You dont have permission to access'));
						return false;
					}
				}
			}
		}
	}
}